﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace GridAddRowBug
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            initTest(ultraGrid1);
        }

        public void initTest(UltraGrid dfG)
        {
            dfG.DisplayLayout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
            dfG.DisplayLayout.GroupByBox.Hidden = true;
            dfG.DisplayLayout.Override.AllowAddNew = AllowAddNew.FixedAddRowOnTop;
            dfG.DisplayLayout.Override.AllowDelete = DefaultableBoolean.True;
            dfG.DisplayLayout.Override.CellClickAction = CellClickAction.CellSelect;
            dfG.DisplayLayout.Override.CellMultiLine = DefaultableBoolean.False;
            dfG.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
            dfG.DisplayLayout.Override.RowSizing = RowSizing.AutoFree;

            dfG.CreationFilter = new CustomCreationFilter();


            dfG.DisplayLayout.Bands[0].Columns["Notes"].AutoSizeEdit = DefaultableBoolean.True;
            dfG.DisplayLayout.Bands[0].Columns["Notes"].CellMultiLine = DefaultableBoolean.True;


            dfG.BeforePerformAction += dfG_BeforePerformAction;
            dfG.ClickCell += dfG_ClickCell;

            dfG.BeforeAutoSizeEdit += dfgrid1_BeforeAutoSizeEdit;

            //-- Mit der Enter-Taste ebenfalls den Editor ein/ausschalten, wie mit F2
            //MakeEnterActLikeF2(dfG);
        }

        void dfgrid1_BeforeAutoSizeEdit(object sender, CancelableAutoSizeEditEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            if (grid == null)
                return;

            // BeforeAutoSizeEdit gets fired when a cell in a column with AutoSizeEdit set to True
            // is going into edit mode.

            // Set the start width of the edit control. This is the width the edit control in the 
            // cell will start out with.
            if (grid.ActiveCell == null)
            {
                e.Cancel = true;
                return;
            }

            bool cancelAutoSizeEdit = true;

            if (grid.ActiveCell.Column.Key == "Notes")
            {
                if (grid.ActiveCell.Column.Width < 400)
                    e.StartWidth = 400;



                if (grid.ActiveCell.Column.CellMultiLine == DefaultableBoolean.True &&
                    grid.ActiveCell.Row.Height < 100)
                    e.StartHeight = 100;

                // Set the max width and height. The UltraGrid will not resize the edit control
                // larger than max height and max width.
                e.MaxHeight = 400;
                e.MaxWidth = 400;

                cancelAutoSizeEdit = false;
            }

            // One can cancel auto-size-edit in which case the cell will do regular editing.
            if (cancelAutoSizeEdit)
                e.Cancel = true;
        }

        static void dfG_ClickCell(object sender, ClickCellEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            if (grid == null)
                return;

            //-------------------
            //--- Bei Klick in die AddRow sofort den Editor starten = Bereit zur Erfassung von Daten
            //-------------------
            if (e.Cell.Row.IsAddRow)
            {
                /* Es wäre schön, wenn beim ERSTEN Klick in die AddRow-Zeile auch immer die erste Zelle aktiviert würde
                 * Es scheint aber keine eingebaute Unterscheidung zu geben, ob die AddRow-Zeile zum ersten Mal geklickt wurde
                 * oder ob während der Bearbeitung der Zeile mit der Maus der Fokus auf eine andere Zelle gesetzt werden sollte
                 * Sobald man mit der Maus klickt, wird der aktive Editor geschlossen - eine Prüfung auf einen aktiven Editor
                 * funktioniert also nicht (sonst hätte man es dran fest machen können)

                //-- Wenn bereits eine Zelle im Editor-Status ist, dann nichts mehr tun
                if ((grid.ActiveCell != null) && (grid.ActiveCell.IsInEditMode))
                    return;

                
                //-- kein aktiver Editor, Dann jetzt die erste Zelle in der Zeile aktivieren 
                //grid.PerformAction(UltraGridAction.FirstCellInRow);
               
                */

                //und Editor starten 
                grid.PerformAction(UltraGridAction.EnterEditMode);
            }
        }

        private  void dfG_BeforePerformAction(object sender, BeforeUltraGridPerformActionEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;

            //-- Tab in der letzten Zelle der AddRow gedrückt? Dann wie bei Enter verfahren:
            //   Zeile speichern und bereit machen für weitere Erfassung

            if (e.UltraGridAction == UltraGridAction.NextCellByTab &&
                grid.CurrentState.HasFlag(
                    UltraGridState.Cell | UltraGridState.CellLast | UltraGridState.InEdit |
                    UltraGridState.Row | UltraGridState.RowFirst | UltraGridState.RowFirstChild |
                    UltraGridState.RowDirty |
                    UltraGridState.FirstRowInGrid |
                    UltraGridState.AddRow | UltraGridState.CellMultiline))
            //UltraGridState.RowLast | UltraGridState.RowLastChild | UltraGridState.LastRowInGrid | 
            {
                //-- Zeile speichern
                grid.PerformAction(UltraGridAction.CommitRow);

                //-- Die erste Zeile wieder activieren
                //grid.PerformAction(UltraGridAction.FirstRowInGrid);
                grid.PerformAction(UltraGridAction.FirstCellInGrid);

                //grid.PerformAction(UltraGridAction.NextRowByTab);
                //grid.Selected.Rows.Clear();

                //-- Editor auf erster Zelle starten
                //grid.PerformAction(UltraGridAction.FirstCellInRow);
                grid.PerformAction(UltraGridAction.EnterEditMode);

                e.Cancel = true;
            }

        }
    }


}
